mia-2dmyoicapgt(1)

NAME
mia-2dmyoicapgt - Run a registration of a series of 2D images.

SYNOPSIS
mia-2dmyoicapgt -i <in-file> -o <out-file> [options]

DESCRIPTION
mia-2dmyoicapgt This program implements a two passs motion compensation algorithm. First a linear registration is run based on a variation of

    Gupta et~al. "Fully automatic registration and segmentation of first-pass myocardial perfusion MR image sequences", Academic Radiology 17, 1375-1385 (https://doi.org/10.1016/j.acra.2010.06.015)

 as described in

    Wollny G, Kellman P, Santos A, Ledesma-Carbayo M-J, "Automatic Motion Compensation of Free Breathing acquired Myocardial Perfusion Data by using Independent Component Analysis", Medical Image Analysis, 2012, (https://doi.org/DOI:10.1016/j.media.2012.02.004)

followed by a non-linear registration based

    Chao Li and Ying Sun, "Nonrigid Registration of Myocardial Perfusion MRI Using Pseudo Ground Truth", In Proc. Medical Image Computing and Computer-Assisted Intervention MICCAI 2009, 165-172, 2009. (https://doi.org/10.1007/978-3-642-04268-3_21)

 Note that for this nonlinear motion correction a preceding linear registration step is usually required. This version of the program may run all registrations in parallel.

OPTIONS

  Pseudo Ground Thruth estimation

    -A --alpha=0.1
        spacial neighborhood penalty weight

    -B --beta=4
        temporal second derivative penalty weight

    -T --rho-thresh=0.85
        correlation threshold for neighborhood analysis

  File-IO

    -i --in-file=(input, required); string
        input perfusion data set

    -o --out-file=(output, required); string
        output perfusion data set

    -r --registered=
        File name base for the registered images. Image type and numbering scheme are taken from the input images as given in the input data set.

    --save-cropped=(output); string
        save cropped set to this file, the image files will use the stem of the name as file name base

    --save-feature=(output); string
        save segmentation feature images and initial ICA mixing matrix

    --save-refs=(output); string
        for each registration pass save the reference images to files with the given name base

    --save-regs=(output); string
        for each registration pass save intermediate registered images

  Help & Info

    -V --verbose=warning
        verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:

        trace - Function call trace
        debug - Debug output
        info - Low level messages
        message - Normal messages
        warning - Warnings
        fail - Report test failures
        error - Report errors
        fatal - Report only fatal errors

    --copyright
        print copyright information

    -h --help
        print this help

    -? --usage
        print a short help

    --version
        print the version number and exit

  ICA

    --fastica=internal
        FastICA implementationto be used
         For supported plugins see PLUGINS:fastica/implementation

    -C --components=0
        ICA components 0 = automatic estimation

    --normalize
        normalized ICs

    --no-meanstrip
        don't strip the mean from the mixing curves

    -s --segscale=0
        segment and scale the crop box around the LV (0=no segmentation)

    -k --skip=0
        skip images at the beginning of the series e.g. because as they are of other modalities

    -m --max-ica-iter=400
        maximum number of iterations in ICA

    -E --segmethod=features
        Segmentation method

        delta-feature - difference of the feature images
        delta-peak - difference of the peak enhancement images
        features - feature images

    -b --min-breathing-frequency=-1
        minimal mean frequency a mixing curve can have to be considered to stem from brething. A healthy rest breating rate is 12 per minute. A negative value disables the test. A value 0.0 forces the series to be identified as acquired with initial breath hold.

  Processing

    --threads=-1
        Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).

  Registration

    -L --linear-optimizer=gsl:opt=simplex,step=1.0
        Optimizer used for minimization of the linear registration The string value will be used to construct a plug-in.
         For supported plugins see PLUGINS:minimizer/singlecost

    --linear-transform=affine
        linear transform to be used The string value will be used to construct a plug-in.
         For supported plugins see PLUGINS:2dimage/transform

    -O --non-linear-optimizer=gsl:opt=gd,step=0.1
        Optimizer used for minimization in the non-linear registration. The string value will be used to construct a plug-in.
         For supported plugins see PLUGINS:minimizer/singlecost

    -a --start-c-rate=16
        start coefficinet rate in spines, gets divided by --c-rate-divider with every pass.

    --c-rate-divider=2
        Cofficient rate divider for each pass.

    -d --start-divcurl=10000
        Start divcurl weight, gets divided by --divcurl-divider with every pass.

    --divcurl-divider=2
        Divcurl weight scaling with each new pass.

    -R --reference=-1
        Global reference all image should be aligned to. If set to a non-negative value, the images will be aligned to this references, and the cropped output image date will be injected into the original images. Leave at -1 if you don't care. In this case all images with be registered to a mean position of the movement

    -w --imagecost=image:weight=1,cost=ssd
        image cost, do not specify the src and ref parameters, these will be set by the program. The string value will be used to construct a plug-in.
         For supported plugins see PLUGINS:2dimage/fullcost

    -l --mg-levels=3
        multi-resolution levels

    -p --linear-passes=3
        linear registration passes (0 to disable)

    -P --nonlinear-passes=3
        non-linear registration passes (0 to disable)

PLUGINS: 1d/splinebc

mirror
    Spline interpolation boundary conditions that mirror on the boundary

    (no parameters)

repeat
    Spline interpolation boundary conditions that repeats the value at the boundary

    (no parameters)

zero
    Spline interpolation boundary conditions that assumes zero for values outside

    (no parameters)

PLUGINS: 1d/splinekernel

bspline
    B-spline kernel creation , supported parameters are:

    d = 3; int in [0, 5]
        Spline degree.

omoms
    OMoms-spline kernel creation, supported parameters are:

    d = 3; int in [3, 3]
        Spline degree.

PLUGINS: 2dimage/cost

lncc
    local normalized cross correlation with masking support., supported parameters are:

    w = 5; uint in [1, 256]
        half width of the window used for evaluating the localized cross correlation.

lsd Least-Squares Distance measure

    (no parameters)

mi  Spline parzen based mutual information., supported parameters are:

    cut = 0; float in [0, 40]
        Percentage of pixels to cut at high and low intensities to remove outliers.

    mbins = 64; uint in [1, 256]
        Number of histogram bins used for the moving image.

    mkernel = [bspline:d=3]; factory
        Spline kernel for moving image parzen hinstogram. For supported plug-ins see PLUGINS:1d/splinekernel

    rbins = 64; uint in [1, 256]
        Number of histogram bins used for the reference image.

    rkernel = [bspline:d=0]; factory
        Spline kernel for reference image parzen hinstogram. For supported plug-ins see PLUGINS:1d/splinekernel

ncc normalized cross correlation.

    (no parameters)

ngf This function evaluates the image similarity based on normalized gradient fields. Various evaluation kernels are available., supported parameters are:

    eval = ds; dict
        plugin subtype. Supported values are:
            sq - square of difference
            ds - square of scaled difference
            dot - scalar product kernel
            cross - cross product kernel

ssd 2D imaga cost: sum of squared differences, supported parameters are:

    autothresh = 0; float in [0, 1000]
        Use automatic masking of the moving image by only takeing intensity values into accound that are larger than the given threshold.

    norm = 0; bool
        Set whether the metric should be normalized by the number of image pixels.

ssd-automask
    2D image cost: sum of squared differences, with automasking based on given thresholds, supported parameters are:

    rthresh = 0; double
        Threshold intensity value for reference image.

    sthresh = 0; double
        Threshold intensity value for source image.

PLUGINS: 2dimage/fullcost

image
    Generalized image similarity cost function that also handles multi-resolution processing. The actual similarity measure is given es extra parameter., supported parameters are:

    cost = ssd; factory
        Cost function kernel. For supported plug-ins see PLUGINS:2dimage/cost

    debug = 0; bool
        Save intermediate resuts for debugging.

    ref =(input, io)
        Reference image. For supported file types see PLUGINS:2dimage/io

    src =(input, io)
        Study image. For supported file types see PLUGINS:2dimage/io

    weight = 1; float
        weight of cost function.

labelimage
    Similarity cost function that maps labels of two images and handles label-preserving multi-resolution processing., supported parameters are:

    debug = 0; int in [0, 1]
        write the distance transforms to a 3D image.

    maxlabel = 256; int in [2, 32000]
        maximum number of labels to consider.

    ref =(input, io)
        Reference image. For supported file types see PLUGINS:2dimage/io

    src =(input, io)
        Study image. For supported file types see PLUGINS:2dimage/io

    weight = 1; float
        weight of cost function.

maskedimage
    Generalized masked image similarity cost function that also handles multi-resolution processing. The provided masks should be densly filled regions in multi-resolution procesing because otherwise the mask information may get lost when downscaling the image. The reference mask and the transformed mask of the study image are combined by binary AND. The actual similarity measure is given es extra parameter., supported parameters are:

    cost = ssd; factory
        Cost function kernel. For supported plug-ins see PLUGINS:2dimage/maskedcost

    ref =(input, io)
        Reference image. For supported file types see PLUGINS:2dimage/io

    ref-mask =(input, io)
        Reference image mask (binary). For supported file types see PLUGINS:2dimage/io

    src =(input, io)
        Study image. For supported file types see PLUGINS:2dimage/io

    src-mask =(input, io)
        Study image mask (binary). For supported file types see PLUGINS:2dimage/io

    weight = 1; float
        weight of cost function.

PLUGINS: 2dimage/io

bmp BMP 2D-image input/output support. The plug-in supports reading and writing of binary images and 8-bit gray scale images. read-only support is provided for 4-bit gray scale images. The color table is ignored and the pixel values are taken as literal gray scale values.

    Recognized file extensions: .BMP, .bmp

    Supported element types:
        binary data, unsigned 8 bit

datapool
    Virtual IO to and from the internal data pool

    Recognized file extensions: .@

dicom
    2D image io for DICOM

    Recognized file extensions: .DCM, .dcm

    Supported element types:
        signed 16 bit, unsigned 16 bit

exr a 2dimage io plugin for OpenEXR images

    Recognized file extensions: .EXR, .exr

    Supported element types:
        unsigned 32 bit, floating point 32 bit

jpg a 2dimage io plugin for jpeg gray scale images

    Recognized file extensions: .JPEG, .JPG, .jpeg, .jpg

    Supported element types:
        unsigned 8 bit

png a 2dimage io plugin for png images

    Recognized file extensions: .PNG, .png

    Supported element types:
        binary data, unsigned 8 bit, unsigned 16 bit

raw RAW 2D-image output support

    Recognized file extensions: .RAW, .raw

    Supported element types:
        binary data, signed 8 bit, unsigned 8 bit, signed 16 bit, unsigned 16 bit, signed 32 bit, unsigned 32 bit, floating point 32 bit, floating point 64 bit

tif TIFF 2D-image input/output support

    Recognized file extensions: .TIF, .TIFF, .tif, .tiff

    Supported element types:
        binary data, unsigned 8 bit, unsigned 16 bit, unsigned 32 bit

vista
    a 2dimage io plugin for vista images

    Recognized file extensions: .-, .V, .VISTA, .v, .vista

    Supported element types:
        binary data, signed 8 bit, unsigned 8 bit, signed 16 bit, unsigned 16 bit, signed 32 bit, unsigned 32 bit, floating point 32 bit, floating point 64 bit

PLUGINS: 2dimage/maskedcost

lncc
    local normalized cross correlation with masking support., supported parameters are:

    w = 5; uint in [1, 256]
        half width of the window used for evaluating the localized cross correlation.

mi  Spline parzen based mutual information with masking., supported parameters are:

    cut = 0; float in [0, 40]
        Percentage of pixels to cut at high and low intensities to remove outliers.

    mbins = 64; uint in [1, 256]
        Number of histogram bins used for the moving image.

    mkernel = [bspline:d=3]; factory
        Spline kernel for moving image parzen hinstogram. For supported plug-ins see PLUGINS:1d/splinekernel

    rbins = 64; uint in [1, 256]
        Number of histogram bins used for the reference image.

    rkernel = [bspline:d=0]; factory
        Spline kernel for reference image parzen hinstogram. For supported plug-ins see PLUGINS:1d/splinekernel

ncc normalized cross correlation with masking support.

    (no parameters)

ssd Sum of squared differences with masking.

    (no parameters)

PLUGINS: 2dimage/transform

affine
    Affine transformation (six degrees of freedom)., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

rigid
    Rigid transformations (i.e. rotation and translation, three degrees of freedom)., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    rot-center = [[0,0]]; 2dfvector
        Relative rotation center, i.e. <0.5,0.5> corresponds to the center of the support rectangle.

rotation
    Rotation transformations (i.e. rotation about a given center, one degree of freedom)., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    rot-center = [[0,0]]; 2dfvector
        Relative rotation center, i.e. <0.5,0.5> corresponds to the center of the support rectangle.

spline
    Free-form transformation that can be described by a set of B-spline coefficients and an underlying B-spline kernel., supported parameters are:

    anisorate = [[0,0]]; 2dfvector
        anisotropic coefficient rate in pixels, nonpositive values will be overwritten by the 'rate' value..

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    kernel = [bspline:d=3]; factory
        transformation spline kernel.. For supported plug-ins see PLUGINS:1d/splinekernel

    penalty = ; factory
        Transformation penalty term. For supported plug-ins see PLUGINS:2dtransform/splinepenalty

    rate = 10; float in [1, inf)
        isotropic coefficient rate in pixels.

translate
    Translation only (two degrees of freedom), supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

vf  This plug-in implements a transformation that defines a translation for each point of the grid defining the domain of the transformation., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

PLUGINS: 2dtransform/splinepenalty

divcurl
    divcurl penalty on the transformation, supported parameters are:

    curl = 1; float in [0, inf)
        penalty weight on curl.

    div = 1; float in [0, inf)
        penalty weight on divergence.

    norm = 0; bool
        Set to 1 if the penalty should be normalized with respect to the image size.

    weight = 1; float in (0, inf)
        weight of penalty energy.

PLUGINS: fastica/implementation

internal
    This is the MIA implementation of the FastICA algorithm.

    (no parameters)

itpp
    This is the IT++ implementation of the FastICA algorithm.

    (no parameters)

PLUGINS: minimizer/singlecost

gdas
    Gradient descent with automatic step size correction., supported parameters are:

    ftolr = 0; double in [0, inf)
        Stop if the relative change of the criterion is below..

    max-step = 2; double in (0, inf)
        Maximal absolute step size.

    maxiter = 200; uint in [1, inf)
        Stopping criterion: the maximum number of iterations.

    min-step = 0.1; double in (0, inf)
        Minimal absolute step size.

    xtola = 0.01; double in [0, inf)
        Stop if the inf-norm of the change applied to x is below this value..

gdsq
    Gradient descent with quadratic step estimation, supported parameters are:

    ftolr = 0; double in [0, inf)
        Stop if the relative change of the criterion is below..

    gtola = 0; double in [0, inf)
        Stop if the inf-norm of the gradient is below this value..

    maxiter = 100; uint in [1, inf)
        Stopping criterion: the maximum number of iterations.

    scale = 2; double in (1, inf)
        Fallback fixed step size scaling.

    step = 0.1; double in (0, inf)
        Initial step size.

    xtola = 0; double in [0, inf)
        Stop if the inf-norm of x-update is below this value..

gsl optimizer plugin based on the multimin optimizers of the GNU Scientific Library (GSL) https://www.gnu.org/software/gsl/, supported parameters are:

    eps = 0.01; double in (0, inf)
        gradient based optimizers: stop when |grad| < eps, simplex: stop when simplex size < eps..

    iter = 100; uint in [1, inf)
        maximum number of iterations.

    opt = gd; dict
        Specific optimizer to be used.. Supported values are:
            simplex - Simplex algorithm of Nelder and Mead
            cg-fr - Flecher-Reeves conjugate gradient algorithm
            cg-pr - Polak-Ribiere conjugate gradient algorithm
            bfgs - Broyden-Fletcher-Goldfarb-Shann
            bfgs2 - Broyden-Fletcher-Goldfarb-Shann (most efficient version)
            gd - Gradient descent.

    step = 0.001; double in (0, inf)
        initial step size.

    tol = 0.1; double in (0, inf)
        some tolerance parameter.

nlopt
    Minimizer algorithms using the NLOPT library, for a description of the optimizers please see 'http://ab-initio.mit.edu/wiki/index.php/NLopt_Algorithms', supported parameters are:

    ftola = 0; double in [0, inf)
        Stopping criterion: the absolute change of the objective value is below this value.

    ftolr = 0; double in [0, inf)
        Stopping criterion: the relative change of the objective value is below this value.

    higher = inf; double
        Higher boundary (equal for all parameters).

    local-opt = none; dict
        local minimization algorithm that may be required for the main minimization algorithm.. Supported values are:
            gn-direct - Dividing Rectangles
            gn-direct-l - Dividing Rectangles (locally biased)
            gn-direct-l-rand - Dividing Rectangles (locally biased, randomized)
            gn-direct-noscal - Dividing Rectangles (unscaled)
            gn-direct-l-noscal - Dividing Rectangles (unscaled, locally biased)
            gn-direct-l-rand-noscale - Dividing Rectangles (unscaled, locally biased, randomized)
            gn-orig-direct - Dividing Rectangles (original implementation)
            gn-orig-direct-l - Dividing Rectangles (original implementation, locally biased)
            ld-lbfgs-nocedal - None
            ld-lbfgs - Low-storage BFGS
            ln-praxis - Gradient-free Local Optimization via the Principal-Axis Method
            ld-var1 - Shifted Limited-Memory Variable-Metric, Rank 1
            ld-var2 - Shifted Limited-Memory Variable-Metric, Rank 2
            ld-tnewton - Truncated Newton
            ld-tnewton-restart - Truncated Newton with steepest-descent restarting
            ld-tnewton-precond - Preconditioned Truncated Newton
            ld-tnewton-precond-restart - Preconditioned Truncated Newton with steepest-descent restarting
            gn-crs2-lm - Controlled Random Search with Local Mutation
            ld-mma - Method of Moving Asymptotes
            ln-cobyla - Constrained Optimization BY Linear Approximation
            ln-newuoa - Derivative-free Unconstrained Optimization by Iteratively Constructed Quadratic Approximation
            ln-newuoa-bound - Derivative-free Bound-constrained Optimization by Iteratively Constructed Quadratic Approximation
            ln-neldermead - Nelder-Mead simplex algorithm
            ln-sbplx - Subplex variant of Nelder-Mead
            ln-bobyqa - Derivative-free Bound-constrained Optimization
            gn-isres - Improved Stochastic Ranking Evolution Strategy
            none - don't specify algorithm

    lower = -inf; double
        Lower boundary (equal for all parameters).

    maxiter = 100; int in [1, inf)
        Stopping criterion: the maximum number of iterations.

    opt = ld-lbfgs; dict
        main minimization algorithm. Supported values are:
            gn-direct - Dividing Rectangles
            gn-direct-l - Dividing Rectangles (locally biased)
            gn-direct-l-rand - Dividing Rectangles (locally biased, randomized)
            gn-direct-noscal - Dividing Rectangles (unscaled)
            gn-direct-l-noscal - Dividing Rectangles (unscaled, locally biased)
            gn-direct-l-rand-noscale - Dividing Rectangles (unscaled, locally biased, randomized)
            gn-orig-direct - Dividing Rectangles (original implementation)
            gn-orig-direct-l - Dividing Rectangles (original implementation, locally biased)
            ld-lbfgs-nocedal - None
            ld-lbfgs - Low-storage BFGS
            ln-praxis - Gradient-free Local Optimization via the Principal-Axis Method
            ld-var1 - Shifted Limited-Memory Variable-Metric, Rank 1
            ld-var2 - Shifted Limited-Memory Variable-Metric, Rank 2
            ld-tnewton - Truncated Newton
            ld-tnewton-restart - Truncated Newton with steepest-descent restarting
            ld-tnewton-precond - Preconditioned Truncated Newton
            ld-tnewton-precond-restart - Preconditioned Truncated Newton with steepest-descent restarting
            gn-crs2-lm - Controlled Random Search with Local Mutation
            ld-mma - Method of Moving Asymptotes
            ln-cobyla - Constrained Optimization BY Linear Approximation
            ln-newuoa - Derivative-free Unconstrained Optimization by Iteratively Constructed Quadratic Approximation
            ln-newuoa-bound - Derivative-free Bound-constrained Optimization by Iteratively Constructed Quadratic Approximation
            ln-neldermead - Nelder-Mead simplex algorithm
            ln-sbplx - Subplex variant of Nelder-Mead
            ln-bobyqa - Derivative-free Bound-constrained Optimization
            gn-isres - Improved Stochastic Ranking Evolution Strategy
            auglag - Augmented Lagrangian algorithm
            auglag-eq - Augmented Lagrangian algorithm with equality constraints only
            g-mlsl - Multi-Level Single-Linkage (require local optimization and bounds)
            g-mlsl-lds - Multi-Level Single-Linkage (low-discrepancy-sequence, require local gradient based optimization and bounds)
            ld-slsqp - Sequential Least-Squares Quadratic Programming

    step = 0; double in [0, inf)
        Initial step size for gradient free methods.

    stop = -inf; double
        Stopping criterion: function value falls below this value.

    xtola = 0; double in [0, inf)
        Stopping criterion: the absolute change of all x-values is below this value.

    xtolr = 0; double in [0, inf)
        Stopping criterion: the relative change of all x-values is below this value.

EXAMPLE
Register the perfusion series given in 'segment.set' by first using automatic ICA estimation to run the linear registration and then the PGT registration. Skip two images at the beginning and otherwiese use the default parameters. Store the result in 'registered.set'.

mia-2dmyoicapgt -i segment.set -o registered.set -k 2

AUTHOR(s)
Gert Wollny

COPYRIGHT
This software is Copyright (c) 1999-2015 Leipzig, Germany and Madrid, Spain. It comes with ABSOLUTELY NO WARRANTY and you may redistribute it under the terms of the GNU GENERAL PUBLIC LICENSE Version 3 (or later). For more information run the program with the option '--copyright'.